mysite/enquetes/urls.py
from django.urls import path
from . import views

app_name = 'enquetes'
urlpatterns = [
    # URL "/enquetes/" --> lista geral das enqquetes
    path('', views.IndexView.as_view(), name='index'),
    # URL "/enquetes/55/" --> detalhes da enquete com "id" 55
    path(
        '<int:pk>/',
        views.DetalhesView.as_view(), name='detalhes'
    ),
    # URL "/enquetes/77/resultado/ --> resultado da enquete 77
    path(
        '<int:pk>/resultado/',
        views.ResultadoView.as_view(), name='resultado'
    ),
]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('raiz.urls')),
    path('enquetes/', include('enquetes.urls')),
]

mysite/raiz/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.index, name='index'),
]

mysite/enquetes/models.py
import datetime
from django.db import models
from django.utils import timezone

class Pergunta(models.Model):
    texto = models.CharField(max_length=150)
    data_pub = models.DateTimeField('Data de publicação')
    def __str__(self):
        return '{} ({})'.format(self.texto, self.id)
    def publicada_recentemente(self):
        agora = timezone.now()
        return self.data_pub >= agora - datetime.timedelta(hours=24)

class Alternativa(models.Model):
    texto = models.CharField(max_length=100)
    quant_votos = models.IntegerField(
        'Quantidade de votos', default=0
    )
    pergunta = models.ForeignKey(Pergunta, on_delete=models.CASCADE)
    def __str__(self):
        return '{} ({})'.format(self.texto, self.id)

mysite/raiz/models.py
from django.db import models

# Create your models here.

mysite/enquetes/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponseRedirect
from django.views import View
from django.urls import reverse
from .models import Pergunta, Alternativa

class IndexView(View):
    def get(self, request, *args, **kwargs):
        enquetes = Pergunta.objects.order_by('-data_pub')[:10]
        contexto = {'pergunta_list': enquetes}
        return render(request, 'enquetes/index.html', contexto)

class DetalhesView(View):
    template = 'enquetes/pergunta_detail.html'

    def resposta(self, request, pergunta, error):
        contexto = {'pergunta': pergunta, 'error':error}
        return render(request, self.template, contexto)

    def get(self, request, *args, **kwargs):
        pergunta_id = kwargs['pk']
        pergunta = get_object_or_404(Pergunta, pk = pergunta_id)
        return self.resposta(request, pergunta, None)

    def post(self, request, *args, **kwargs):
        pergunta_id = kwargs['pk']
        pergunta = get_object_or_404(Pergunta, pk=pergunta_id)
        try:
            id_alternativa = request.POST['escolha']
            alt = pergunta.alternativa_set.get(pk=id_alternativa)
        except (KeyError, Alternativa.DoesNotExist):
            error = 'Você precisa selecionar uma alternativa.'
            return self.resposta(request, pergunta, error)
        else:
            alt.quant_votos += 1
            alt.save()
            return HttpResponseRedirect(reverse(
                'enquetes:resultado', args=(pergunta.id,)
            ))

class ResultadoView(View):
    def get(self, request, *args, **kwargs):
        pergunta_id = kwargs['pk']
        pergunta = get_object_or_404(Pergunta, pk = pergunta_id)
        contexto = {'pergunta': pergunta}
        return render(request, 'enquetes/resultado.html', contexto)


####
## Histórico de Versões
"""
--> View INDEX - Versão 1
def index(request):
    enquetes = Pergunta.objects.all()
    template = loader.get_template('enquetes/index.html')
    contexto = {'lista_enquetes': enquetes}
    return HttpResponse(template.render(contexto, request))

--> View INDEX - Versão 2
def index(request):
    enquetes = Pergunta.objects.order_by('-data_pub')[:10]
    contexto = {'lista_enquetes': enquetes}
    return render(request, 'enquetes/index.html', contexto)

--> View INDEX - Versão 3
class IndexView(generic.ListView):
    template_name = 'enquetes/index.html'
    def get_queryset(self):
        return Pergunta.objects.order_by('-data_pub')[:10]

--> View DETALHES - Versão 1
def detalhes(request, pergunta_id):
    resultado = 'DETALHES da enquete de número %s'
    return HttpResponse(resultado % pergunta_id)

--> View DETALHES - Versão 2
def detalhes(request, pergunta_id):
    pergunta = get_object_or_404(Pergunta, pk = pergunta_id)
    contexto = {'enquete': pergunta}
    return render(request, 'enquetes/detalhes.html', contexto)

--> View RESULTADO - Versão 1
class ResultadoView(generic.DetailView):
    model = Pergunta
    template_name = 'enquetes/resultado.html'


--> View VOTAÇÃO - Versão 1
def votacao(request, pergunta_id):
    pergunta = get_object_or_404(Pergunta, pk=pergunta_id)
    try:
        id_alternativa = request.POST['escolha']
        alt = pergunta.alternativa_set.get(pk=id_alternativa)
    except (KeyError, Alternativa.DoesNotExist):
        contexto = {
            'pergunta': pergunta,
            'error': 'Você precisa selecionar uma alternativa.'
        }
        return render(request, 'enquetes/pergunta_detail.html', contexto)
    else:
        alt.quant_votos += 1
        alt.save()
        return HttpResponseRedirect(reverse(
            'enquetes:resultado', args=(pergunta.id,)
        ))
"""

mysite/raiz/views.py
from django.shortcuts import render

def index(request):
    return render(request, 'raiz/index.html')

mysite/enquetes/templates/enquetes/index.html
<html>
    <head>
        <title>App Enquetes</title>
    </head>
    <body>
        <h1>Aplicação de Enquetes - DSWeb 2024.1</h1>
        {% if pergunta_list %}
          <h3>Lista das Enquetes Cadastradas:</h3>
          <ul>
            {% for p in pergunta_list %}
              <li>
                <a href="{% url 'enquetes:detalhes' p.id %}">
                  {{ p.texto }}
                </a>&nbsp;&nbsp;
                (<a href="{% url 'enquetes:resultado' p.id %}">ver PARCIAL
                </a>)
              </li>
            {% endfor %}
          </ul>
        {% else %}
          <h3>Nenhuma enquete cadastrada até o momento!</h3>
        {% endif %}
    </body>
</html>

mysite/enquetes/templates/enquetes/pergunta_detail.html
<html>
    <head>
        <title>App Enquetes</title>
    </head>
    <body>
        <h1>Aplicação de Enquetes - DSWeb 2024.1</h1>
        <h2>Enquete #{{ pergunta.id }}</h2>
        <h2>{{ pergunta.texto }}</h2>
        <p><i>{{ pergunta.data_pub }}</i></p>
        {% if error %}
          <dt><b>Erro: {{ error }}</b></dt>
        {% endif %}
        <p>Selecione a alternativa desejada:</p>
        <form action="{% url 'enquetes:detalhes' pergunta.id %}"
              method="post">
          {% csrf_token %}
          <ul>
          {% for alt in pergunta.alternativa_set.all %}
            <li>
              <input type="radio" name="escolha" value="{{ alt.id }}"
                     id="alt{{ forloop.counter }}"/>
              <label for="alt{{ forloop.counter }}">
                {{ alt.texto }}
              </label>
            </li>
          {% endfor %}
          </ul>
          <input type="submit" value="Registre o seu voto"/>
        </form>
        <hr>
        <a href="{% url 'enquetes:index' %}">Voltar</a>
    </body>
</html>

mysite/enquetes/templates/enquetes/resultado.html
<html>
    <head>
        <title>App Enquetes</title>
    </head>
    <body>
        <h1>Aplicação de Enquetes - DSWeb 2024.1</h1>
        <h2>PARCIAL da Enquete #{{ pergunta.id }}</h2>
        <h2>{{ pergunta.texto }}</h2>
        <p><i>{{ pergunta.data_pub }}</i></p>
        <p>Quantidade de votos por alternativas:</p>
        <ul>
          {% for alt in pergunta.alternativa_set.all %}
            <li>
              {{ alt.texto }} == {{ alt.quant_votos }}
              voto{{ alt.quant_votos | pluralize }}
            </li>
          {% endfor %}
        </ul>
        <hr>
        <a href="{% url 'enquetes:detalhes' pergunta.id %}">Votar novamente?</a> |
        <a href="{% url 'enquetes:index' %}">Voltar</a>
    </body>
</html>

mysite/raiz/templates/raiz/index.html
<html>
    <head>
        <title>DSWeb 2024.1</title>
    </head>
    <body>
        <h1>Disciplina DSWeb 2024.1</h1>
        <h3>Aplicações Criadas:</h3>
        <ol>
            <li><a href="/enquetes/">
                Aplicação de Enquetes
            </a></li>
        </ol>
    </body>
</html>